'use strict';

module.exports = class BaseController {
  constructor(app, ctx, next) {
    this.app = app
    this.ctx = ctx
    this.next = next
    this.renderType = 'default'
    this.data = {}
    this.tpl = 'index'
    
    this.result = '{verb}() call result'
  }

  register() {
    throw new Error("This method must be overwritten!");
  }

  // lifecycle
  before() {
    
  }
  
  alias() {
    if (this.ctx.request.body) {
        this.pp = this.ctx.request.body
    }
  }
  
  render() {
    if (this.renderType === 'default') {
      return this.ctx.body = this.result
    }
    
    if (this.renderType === 'view') {
      var obj = {
        data: this.data,
        tpl: this.tpl
      }
      Object.assign(obj, this.result);

      return this.ctx.render(obj.tpl, obj.data)
    }
    
    return ctx.body = "ctrl instanceof Controller error"
  }
  
  after() {
    
  }
}
